/******************************************************************************
 * Copyright 2022-2023 TypeFox GmbH
 * This program and the accompanying materials are made available under the
 * terms of the MIT License, which is available in the project root.
 ******************************************************************************/
import { DefaultNameProvider } from "langium";
import { isFunctionDefinition, isSchemaDefinition, isTableDefinition } from "./generated/ast.js";
export class SqlNameProvider extends DefaultNameProvider {
    getName(node) {
        if (isSchemaDefinition(node) || isTableDefinition(node) || isFunctionDefinition(node)) {
            return this.getDefinitionName(node.reference);
        }
        else {
            return super.getName(node);
        }
    }
    getNameNode(node) {
        if (isSchemaDefinition(node) || isTableDefinition(node) || isFunctionDefinition(node)) {
            return this.getDefinitionNode(node.reference);
        }
        else {
            return super.getNameNode(node);
        }
    }
    getDefinitionName(reference) {
        var _a;
        return ((_a = reference === null || reference === void 0 ? void 0 : reference.element) === null || _a === void 0 ? void 0 : _a.$refText) || undefined;
    }
    getDefinitionNode(reference) {
        var _a;
        return (_a = reference === null || reference === void 0 ? void 0 : reference.element) === null || _a === void 0 ? void 0 : _a.$refNode;
    }
}
//# sourceMappingURL=sql-name-provider.js.map