/******************************************************************************
 * Copyright 2022-2023 TypeFox GmbH
 * This program and the accompanying materials are made available under the
 * terms of the MIT License, which is available in the project root.
 ******************************************************************************/
import { DefaultWorkspaceManager, } from "langium";
import { URI } from "vscode-uri";
export class SqlWorkspaceManager extends DefaultWorkspaceManager {
    constructor(services) {
        super(services);
        this.initializationFiles = [];
        this.factory = services.workspace.LangiumDocumentFactory;
        services.lsp.LanguageServer.onInitialize(params => {
            var _a;
            const files = (_a = params.initializationOptions) === null || _a === void 0 ? void 0 : _a.files;
            if (Array.isArray(files)) {
                this.initializationFiles.push(...files);
            }
        });
    }
    async loadAdditionalDocuments(_folders, collector) {
        for (let i = 0; i < this.initializationFiles.length; i++) {
            const file = this.initializationFiles[i];
            const uri = URI.parse(`inmemory:///builtin_${i}.sql`);
            const document = this.factory.fromString(file, uri);
            collector(document);
        }
    }
}
//# sourceMappingURL=sql-workspace-manager.js.map